'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

const compress = query => query.replace(/#.*\n/g, '').replace(/[\s|,]*\n+[\s|,]*/g, ' ').replace(/\s?([:,{}()=@])\s?/g, '$1').replace(/\s([$.])/g, '$1').trim();

function _default(api) {
  let changed = [];
  return {
    name: 'transform-compress-graphql',
    visitor: {
      Program: {
        enter: () => {
          changed = [];
        },
        exit: () => {// log what's changed?
        }
      },

      TaggedTemplateExpression(path, state) {
        const _path$node = path.node,
              tag = _path$node.tag,
              quasi = _path$node.quasi;
        const _state$opts = state.opts,
              _state$opts$tagName = _state$opts.tagName,
              tagName = _state$opts$tagName === void 0 ? 'gql' : _state$opts$tagName,
              _state$opts$tagFuncti = _state$opts.tagFunction,
              tagFunction = _state$opts$tagFuncti === void 0 ? 'String.raw' : _state$opts$tagFuncti;

        if (tag.name === tagName && !path.scope.hasBinding(tagName)) {
          tag.name = tagFunction;
          quasi.quasis.map(({
            value
          }) => {
            const part = compress(value.raw);
            value.raw = part;
            value.cooked = part;
          });
        }
      }

    }
  };
}